package com.qmth.sop.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.sop.business.entity.SysDingDate;
import com.qmth.sop.business.mapper.SysDingDateMapper;
import com.qmth.sop.business.service.SysDingDateService;
import com.qmth.sop.common.enums.DingDateTypeEnum;
import org.springframework.stereotype.Service;

import java.time.DayOfWeek;
import java.time.LocalDate;

/**
 * 考勤特殊日期 服务实现.
 *
 * @author: shudonghui
 * @date: 2023-08-10 13:52:06
 * @version: 1.0
 * @email: shudonghui@qmth.com.cn
 * @Company: www.qmth.com.cn
 */
@Service
public class SysDingDateServiceImpl extends ServiceImpl<SysDingDateMapper, SysDingDate> implements SysDingDateService {


    @Override
    public DingDateTypeEnum getDingDateType(LocalDate date) {
        SysDingDate sysDingDate = this.getOne(new QueryWrapper<SysDingDate>().lambda().eq(SysDingDate::getYear, date.getYear()).eq(SysDingDate::getMonth, date.getMonthValue()).eq(SysDingDate::getDay, date.getDayOfMonth()));
        if (sysDingDate != null) {
            return sysDingDate.getType();
        } else if (date.getDayOfWeek() != DayOfWeek.SATURDAY && date.getDayOfWeek() != DayOfWeek.SUNDAY) {
            return DingDateTypeEnum.WEEKDAY;
        } else {
            return DingDateTypeEnum.WEEKEND;
        }
    }
}